#ifndef WEENSYOS_LIB_H
#define	WEENSYOS_LIB_H
#include "types.h"

// <string.h> emulation (in lib.c)
void *memcpy(void *dst, const void *src, size_t n);
void *memset(void *v, int c, size_t n);
int strlen(const char *s);

// <stdarg.h> emulation (from NetBSD)
typedef char *va_list;
#define	__va_size(type) \
	(((sizeof(type) + sizeof(long) - 1) / sizeof(long)) * sizeof(long))
#define	va_start(ap, last) \
	((ap) = (va_list)&(last) + __va_size(last))
#define	va_arg(ap, type) \
	(*(type *)((ap) += __va_size(type), (ap) - __va_size(type)))
#define	va_end(ap)	((void)0)

#endif /* !WEENSYOS_LIB_H */
